org.eclipse.emf.cdo.common.model

## Enum CDOPackageUnit.Type

- java.lang.Object
- - java.lang.Enum<CDOPackageUnit.Type>
  - - org.eclipse.emf.cdo.common.model.CDOPackageUnit.Type

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<CDOPackageUnit.Type>
  Enclosing interface:
    CDOPackageUnit

      public static enum CDOPackageUnit.Type
      extends java.lang.Enum<CDOPackageUnit.Type>

  Describes the instances of `classes` of a `package unit`.
  Author:
    Eike Stepper

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `DYNAMIC` The type of models that are not generated at all but rather dynamically contructed at runtime.
    `LEGACY` The type of models that are not generated specifically for the usage with CDO.
    `NATIVE` The type of models that are generated specifically for the usage with CDO.
    `UNKNOWN` Used to indicate that the type of a model could not be determined.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `checkNotUnknown()`
    `boolean` | `isGenerated()` Returns `true` if this type is either `NATIVE` or `LEGACY`, `false` otherwise.
    `static CDOPackageUnit.Type` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static CDOPackageUnit.Type[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### NATIVE

          public static final CDOPackageUnit.Type NATIVE

      The type of models that are generated specifically for the usage with CDO. Instances of `classes` of these models can be directly cast to InternalCDOObject.

    - #### LEGACY

          public static final CDOPackageUnit.Type LEGACY

      The type of models that are not generated specifically for the usage with CDO. Instances of `classes` of these models can not be directly cast to InternalCDOObject.

    - #### DYNAMIC

          public static final CDOPackageUnit.Type DYNAMIC

      The type of models that are not generated at all but rather dynamically contructed at runtime. Instances of `classes` of these models can be directly cast to InternalCDOObject, i.e. they're implicitely native.

    - #### UNKNOWN

          public static final CDOPackageUnit.Type UNKNOWN

      Used to indicate that the type of a model could not be determined. Refer to the `package type registry` on how to deal with this scenario.

  - ### Method Detail

    - #### values

          public static CDOPackageUnit.Type[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (CDOPackageUnit.Type c : CDOPackageUnit.Type.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static CDOPackageUnit.Type valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### isGenerated

          public boolean isGenerated()

      Returns `true` if this type is either `NATIVE` or `LEGACY`, `false` otherwise.

    - #### checkNotUnknown

          public void checkNotUnknown()
                               throws java.lang.IllegalStateException

      Throws:
        `java.lang.IllegalStateException` - if this type is `UNKNOWN`.

Copyright (c) 2014 Eike Stepper (Berlin, Germany) and others.
All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0 which accompanies this distribution, and is available at http://www.eclipse.org/legal/epl-v10.html